<?php
namespace Wics;

class CurlRequest{

	public $key;
	public $host;
	public $result;
	public $ch;

	public function __construct($method, $endpoint){

		
		$this->host = \Wics\Settings::getSetting("url");
		
		$this->ch = curl_init();
		curl_setopt($this->ch, CURLOPT_URL, $this->host . $endpoint);
		curl_setopt($this->ch, CURLOPT_HTTPHEADER, array(
		"Content-Type: application/json"));
		curl_setopt($this->ch, CURLOPT_USERPWD, \Wics\Settings::getSetting('username') . ":" . \Wics\Settings::getSetting('password'));
		curl_setopt($this->ch, CURLOPT_CUSTOMREQUEST, $method);
		curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($this->ch, CURLOPT_SSL_VERIFYPEER, false);

	}

	public function execute(){
		$this->result = curl_exec ($this->ch);
		curl_close ($this->ch);
	}

	public function addObject($postfields){
		error_log(json_encode($postfields));
		curl_setopt($this->ch,CURLOPT_POSTFIELDS, json_encode($postfields));
	}

	public function getResult(){
		return json_decode($this->result);
	}
}


?>